## libcuckoo 0~git20210805

=== CMakeLists.txt ===
# for write_basic_package_version_file()
include(CMakePackageConfigHelpers)

# we require the use of threads
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# generate a version for cmake to use with find_package(libcuckoo)
set (libcuckoo_VERSION "${libcuckoo_VERSION_MAJOR}.${libcuckoo_VERSION_MINOR}")
set (libcuckoo_VERSION "${libcuckoo_VERSION}.${libcuckoo_VERSION_PATCH}")

# libcuckoo is an interface (all headers) library target
add_library(libcuckoo INTERFACE)

# tag libcuckoo target with a c++11 feature so that libcuckoo users
# will have c++11 turned on in their compile when they use this target.
# XXX: newer cmakes have a "cxx_std_11" feature that could be used
target_compile_features (libcuckoo INTERFACE cxx_constexpr)

# Include relative to the base directory
target_include_directories(libcuckoo INTERFACE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)

# switch on threading for all targets that link with libcuckoo
target_link_libraries(libcuckoo INTERFACE Threads::Threads)

# cmake packaging
set (libcuckoo_pkgloc "share/cmake/libcuckoo")

write_basic_package_version_file(
    "libcuckoo-config-version.cmake" VERSION ${libcuckoo_VERSION}
    COMPATIBILITY AnyNewerVersion)

install(TARGETS libcuckoo EXPORT libcuckoo-targets)
install(EXPORT libcuckoo-targets
        DESTINATION ${libcuckoo_pkgloc}
        FILE "libcuckoo-targets.cmake")
install(FILES libcuckoo-config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/libcuckoo-config-version.cmake
              DESTINATION ${libcuckoo_pkgloc})
install(
FILES
    cuckoohash_config.hh
    cuckoohash_map.hh
    cuckoohash_util.hh
    bucket_container.hh
DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/libcuckoo
)

=== Catch/CMakeLists.txt ===
add_library(catch INTERFACE)
target_include_directories(catch INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/single_include>
)

=== pcg/CMakeLists.txt ===
add_library(pcg INTERFACE)

# Include relative to the base directory
target_include_directories(pcg INTERFACE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
)

=== unit-tests/CMakeLists.txt ===
add_library(int_int_table STATIC int_int_table.cc)
target_link_libraries(int_int_table libcuckoo)

add_executable(unit_tests
    test_constructor.cc
    test_hash_properties.cc
    test_heterogeneous_compare.cc
    test_iterator.cc
    test_maximum_hashpower.cc
    test_minimum_load_factor.cc
    test_noncopyable_types.cc
    test_resize.cc
    test_runner.cc
    test_user_exceptions.cc
    test_locked_table.cc
    test_c_interface.cc
    test_bucket_container.cc
    unit_test_util.cc
    unit_test_util.hh
)

target_link_libraries(unit_tests
    PRIVATE catch
    PRIVATE libcuckoo
    PRIVATE int_int_table
)

add_test(NAME unit_tests COMMAND unit_tests)

=== debian/changelog ===
libcuckoo (0~git20210805-3) unstable; urgency=medium

  * add patch to fix warnings in building and the test_resize test itself
    on 32bit (from upstream github)

 -- Rene Engelhard <rene@debian.org>  Mon, 27 Dec 2021 22:18:41 +0100

libcuckoo (0~git20210805-2) unstable; urgency=medium

  * upload source-only 

 -- Rene Engelhard <rene@debian.org>  Tue, 23 Nov 2021 20:16:44 +0100

libcuckoo (0~git20210805-1) unstable; urgency=medium

  * Initial release

 -- Rene Engelhard <rene@debian.org>  Mon, 06 Sep 2021 21:48:43 +0200

=== debian/control ===
Source: libcuckoo
Section: devel
Priority: optional
Maintainer: Debian LibreOffice Maintainers <debian-openoffice@lists.debian.org>
Uploaders: Rene Engelhard <rene@debian.org>
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.6.0
Homepage: https://github.com/efficient/libcuckoo
#Vcs-Browser: https://salsa.debian.org/debian/libcuckoo
#Vcs-Git: https://salsa.debian.org/debian/libcuckoo.git
Rules-Requires-Root: no

Package: libcuckoo-dev
Architecture: all
Depends: ${misc:Depends}
Description: high-performance, concurrent hash table (header-only) library
 libcuckoo provides a high-performance, compact hash table that allows multiple
 concurrent reader and writer threads.
 .
 It is a header-only library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_TESTS=1 -DBUILD_UNIT_TESTS=1

override_dh_auto_test:
	dh_auto_test -- ARGS+=--verbose
endif

=== debian/tests/control ===
Tests: test
Depends: @builddeps@, @
Restrictions: allow-stderr, rw-build-tree

## libcuckoo 0.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)
project(libcuckoo
    VERSION 0.3.1
    LANGUAGES C CXX)

# put these in the cache so they show up in ccmake
option (BUILD_EXAMPLES "build example libcuckoo programs")

# Add the libcuckoo interface target
add_subdirectory(libcuckoo)

# Add C interface target
add_subdirectory(libcuckoo-c)

# Build examples
if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

# Build tests -- this only builds tests that were specified
enable_testing()
add_subdirectory(tests)

=== libcuckoo/CMakeLists.txt ===
# for write_basic_package_version_file()
include(CMakePackageConfigHelpers)

# we require the use of threads
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# generate a version for cmake to use with find_package(libcuckoo)
set (libcuckoo_VERSION "${libcuckoo_VERSION_MAJOR}.${libcuckoo_VERSION_MINOR}")
set (libcuckoo_VERSION "${libcuckoo_VERSION}.${libcuckoo_VERSION_PATCH}")

# libcuckoo is an interface (all headers) library target
add_library(libcuckoo INTERFACE)
add_library(libcuckoo::libcuckoo ALIAS libcuckoo)

# tag libcuckoo target with a c++11 feature so that libcuckoo users
# will have c++11 turned on in their compile when they use this target.
# XXX: newer cmakes have a "cxx_std_11" feature that could be used
target_compile_features (libcuckoo INTERFACE cxx_constexpr)

# Include relative to the base directory
target_include_directories(libcuckoo INTERFACE
    $<BUILD_INTERFACE:${libcuckoo_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)

# switch on threading for all targets that link with libcuckoo
target_link_libraries(libcuckoo INTERFACE Threads::Threads)

# cmake packaging
set (libcuckoo_pkgloc "share/cmake/libcuckoo")

write_basic_package_version_file(
    "libcuckoo-config-version.cmake" VERSION ${libcuckoo_VERSION}
    COMPATIBILITY AnyNewerVersion)

install(TARGETS libcuckoo EXPORT libcuckoo-targets)
install(EXPORT libcuckoo-targets
        NAMESPACE libcuckoo::
        DESTINATION ${libcuckoo_pkgloc}
        FILE "libcuckoo-targets.cmake")
install(FILES libcuckoo-config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/libcuckoo-config-version.cmake
              DESTINATION ${libcuckoo_pkgloc})
install(
FILES
    cuckoohash_config.hh
    cuckoohash_map.hh
    cuckoohash_util.hh
    bucket_container.hh
DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/libcuckoo
)

=== tests/stress-tests/CMakeLists.txt ===
add_executable(stress_checked stress_checked.cc)
target_link_libraries(stress_checked
    PRIVATE test_util
    PRIVATE pcg
    PRIVATE libcuckoo
)

add_executable(stress_unchecked stress_unchecked.cc)
target_link_libraries(stress_unchecked
    PRIVATE test_util
    PRIVATE pcg
    PRIVATE libcuckoo
)

add_test(NAME stress_checked COMMAND stress_checked)
add_test(NAME stress_unchecked COMMAND stress_unchecked)

=== tests/universal-benchmark/CMakeLists.txt ===
add_executable(universal_benchmark universal_benchmark.cc)

# put these in the cache so they show up in ccmake
set (UNIVERSAL_KEY uint64_t CACHE STRING "set the key type used by the universal benchmark")
set (UNIVERSAL_VALUE uint64_t CACHE STRING "set the value type used by the universal benchmark")
set (UNIVERSAL_TABLE LIBCUCKOO CACHE STRING "set the table type used by the universal benchmark")
option (UNIVERSAL_TRACKING_ALLOCATOR "if on, also sample memory usage in the universal benchmark")

target_link_libraries(universal_benchmark
    PRIVATE test_util
    PRIVATE libcuckoo
    PRIVATE pcg
)

target_compile_options(universal_benchmark
    PRIVATE -DKEY=${UNIVERSAL_KEY}
    PRIVATE -DVALUE=${UNIVERSAL_VALUE}
    PRIVATE -D${UNIVERSAL_TABLE}
)

if(UNIVERSAL_TRACKING_ALLOCATOR)
    target_compile_options(universal_benchmark PRIVATE -DTRACKING_ALLOCATOR)
endif()

add_test(NAME pure_read
         COMMAND universal_benchmark --reads 100 --prefill 75 --total-ops 500 --initial-capacity 23)
add_test(NAME pure_insert
         COMMAND universal_benchmark --inserts 100 --total-ops 75 --initial-capacity 23)
add_test(NAME pure_erase
         COMMAND universal_benchmark --erases 100 --prefill 75 --total-ops 75 --initial-capacity 23)
add_test(NAME pure_update
         COMMAND universal_benchmark --updates 100 --prefill 75 --total-ops 500 --initial-capacity 23)
add_test(NAME pure_upsert
         COMMAND universal_benchmark --upserts 100 --prefill 25 --total-ops 200 --initial-capacity 23)

add_test(NAME insert_expansion
         COMMAND universal_benchmark --inserts 100 --initial-capacity 4 --total-ops 13107200)
add_test(NAME read_insert_expansion
         COMMAND universal_benchmark --reads 80 --inserts 20 --initial-capacity 10 --total-ops 4096000)

=== debian/changelog ===
libcuckoo (0.3.1-3) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 4.6.0 to 4.7.0.
  * Use wrap-and-sort -at for debian control files.
  * Trim trailing whitespace.
  * Refer to common license file for Apache-2.0.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Marked libcuckoo-dev as Multi-Arch: foreign.
  * Added d/watch setup.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 17 Nov 2024 21:47:04 +0100

libcuckoo (0.3.1-2) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group <packages@qa.debian.org>. (see: #1018229)
  * debian/control: Remove Uploaders field.

 -- Marcos Talau <talau@debian.org>  Sun, 13 Nov 2022 08:47:02 -0300

libcuckoo (0.3.1-1) unstable; urgency=medium

  * "New" upstream version 0.3.1

  * mark the test as flaky (and consequently ignore make check errors since
    it's actually the same test)

 -- Rene Engelhard <rene@debian.org>  Mon, 22 Aug 2022 10:33:52 +0200

=== debian/control ===
Source: libcuckoo
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
Standards-Version: 4.7.0
Homepage: https://github.com/efficient/libcuckoo
#Vcs-Browser: https://salsa.debian.org/debian/libcuckoo
#Vcs-Git: https://salsa.debian.org/debian/libcuckoo.git
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libcuckoo
Vcs-Git: https://salsa.debian.org/debian/libcuckoo.git

Package: libcuckoo-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: high-performance, concurrent hash table (header-only) library
 libcuckoo provides a high-performance, compact hash table that allows multiple
 concurrent reader and writer threads.
 .
 It is a header-only library.

=== debian/rules ===
--- 
+++ 
@@ -10,5 +10,5 @@
 	-DBUILD_TESTS=1 -DBUILD_UNIT_TESTS=1
 
 override_dh_auto_test:
-	dh_auto_test -- ARGS+=--verbose
+	-dh_auto_test -- ARGS+=--verbose
 endif

=== debian/tests/control ===
Tests: test
Depends: @,
         @builddeps@,
Restrictions: allow-stderr, rw-build-tree, flaky

=== debian/watch ===
version=4
https://github.com/efficient/libcuckoo/tags .*/v@ANY_VERSION@@ARCHIVE_EXT@
